HDU 1622

http://acm.hdu.edu.cn/showproblem.php?pid=1622

白书上6.3.2二叉树层次遍历的例题,层次遍历用bfs,建立二叉树,很基础的题目

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <queue>

using namespace std;

struct node{
    int vis,v;
    node *l,*r;
};

node *root;

node* newnode(){
    node *u=new node;
    if(u!=NULL){
        u->vis=0;
        u->l=u->r=NULL;
    }
    return u;
}

int failed;

void addnode(int v,char* s){
    int len=strlen(s);
    node* u=root;
    for(int i=0;i<len;i++){
        if(s[i]==‘L‘){
            if(u->l==NULL)u->l=newnode();
            u=u->l;
        }
        else if(s[i]==‘R‘){
            if(u->r==NULL)u->r=newnode();
            u=u->r;
        }
    }
    if(u->vis)failed=1;
    u->v=v;
    u->vis=1;
}

char s[305];

void remove_tree(node* u){
    if(u==NULL)return;
    remove_tree(u->l);
    remove_tree(u->r);
    delete u;
}

int input(){
    failed=0;
    remove_tree(root);
    root=newnode();
    while(1){
        if(scanf("%s",s)==EOF)return 0;
        if(!strcmp(s,"()"))break;
        int v;
        sscanf(&s[1],"%d",&v);
        addnode(v,strchr(s,‘,‘)+1);
    }
    return 1;
}

int st,ans[305];

int bfs(){
    queue <node*> q;
    q.push(root);
    while(!q.empty()){
        node* u=q.front();
        q.pop();
        if(u->vis==0)return 0;
        ans[st++]=u->v;
        if(u->l!=NULL)q.push(u->l);
        if(u->r!=NULL)q.push(u->r);
    }
    return 1;
}

int main(){
    while(input()){
        if(failed)puts("not complete");
        else{
            st=0;
            if(!bfs())puts("not complete");
            else{
                for(int i=0;i<st;i++){
                    if(!i)
                        printf("%d",ans[i]);
                    else
                        printf(" %d",ans[i]);
                }
                putchar(‘\n‘);
            }
        }
    }
    return 0;
}

时间: 2024-10-12 07:57:21

HDU 1622的相关文章

hdu 1622 Trees on the level

题意:按层次遍历二叉树 思路:对于不会建树的同学,直接广搜即可 #include <iostream> #include <stdio.h> #include <string.h> #include <algorithm> #include <map> #include <string> #include <queue> using namespace std; #define maxn 300 char s[maxn];

【二叉树】hdu 1622 Trees on the level

[题意] 给定一棵树每个结点的权重和路径(路径用LR串表示),输出这棵树的层次遍历 [思路] 注意输入输出,sscanf用来格式化地截取需要的数据,strchr来在字符串中查找字符的位置 [Accepted] #include<iostream> #include<cstdio> #include<string> #include<cstring> #include<algorithm> #include<queue> using n

转载:hdu 题目分类 (侵删)

转载:from http://blog.csdn.net/qq_28236309/article/details/47818349 基础题:1000.1001.1004.1005.1008.1012.1013.1014.1017.1019.1021.1028.1029. 1032.1037.1040.1048.1056.1058.1061.1070.1076.1089.1090.1091.1092.1093. 1094.1095.1096.1097.1098.1106.1108.1157.116

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name